/*
 	v0.1 - [01.03.2012] First release
	v0.2 - [04.03.2012] 1)added menu 2)fixed few bugs 3)added config
	v0.2a - [05.03.2012] 1)added new option in menu 2)new connect code 3)few bug fix
	v0.2b - [08.03.2012] 1)fixed freeze mode 2)now - no need jk_botti cfg change ... 3)fixed random models
	v0.2c - [09.03.2012] 1)fixed set-bot names 2)fixed double names
	v0.2c1 - [10.03.2012] 1)removed message :D "GOOD!!!"
	v0.2c2 - [16.03.2012] 1)i hope fixed error msg with - get array size 2)fixed little bug on disconnect jk_botti
        v0.2c3 - [17.05.2012] 1)Optimizations

	Special Thanks to: KORD_12.7 && PRoSToTeM@

	http://aghl.ru/forum/ - Russian Half-Life and Adrenaline Gamer Community
*/

#include <amxmodx>
#include <fakemeta>
#include <fun>
#include <hamsandwich>
#include <hl>

/* ================= */

#define Check_Time		15.0		// timer
#define ADMIN_FLAGS		ADMIN_IMMUNITY	// flags to control 'jk_botti', can be - (ADMIN_BAN | ADMIN_CFG) ...

/* ================= */

enum _:Add_Bot_Flags(<<= 1)
{
	add_False = 1,
	add_Reset,
	add_True,
	add_No_Nickname
}

enum _:Plugin_Flags(<<= 1)
{
	flag_Block = 1,
	flag_ai_Enable,
	flag_Freeze,
	flag_Observer,
	flag_Skip,
	flag_Warning
}

enum _:Bot_Stop
{
	Bot_Freeze = 1,
	Bot_UN_Freeze
}

enum _:Plugin_Data
{
	_Max_Players,
	_Clients[32],
	_Default_Difficulty,
	_Available_Slots,
	_offset_difficulty,
	_offset_slots,
	_bit_bot,
	_bit_jk_botti,
	_Total_jk_botti_Bots,
	_Clients_Total,
	_Plugin_Flags,
	_Bot_Level,
	_Max_Bots,
	_Max_Names,
	_Simple_Difficulty
}

enum _:Bot_Data
{
	_Timed_Offset,
	_Group[32]
}

//#define DEBUG_ON // debug mode

#define PRIORITY_DIFFICULTY		g_plugin_data[_Simple_Difficulty]
#define VALUE_SLOTS			g_plugin_data[_Available_Slots]
#define VALUE_DIFFICULTY		g_plugin_data[_Default_Difficulty]
#define GET_VALUE_FROM_OFFSET(%1)	read_config_line(%1)
#define OFFSET_SLOTS			g_plugin_data[_offset_slots]
#define OFFSET_DIFFICULTY		g_plugin_data[_offset_difficulty]
#define CHANGE_SLOTS(%1)		change_value(Single, %1)
#define CHANGE_DIFFICULTY(%1)		change_value(None, %1)
#define CONFIG_PATH			"/addons/amxmodx/configs/jk_botti_ai_control.ini"
#define BOT_CONFIG_PATH			"/addons/jk_botti/jk_botti.cfg"
#define BOT_NAMES_CONFIG_PATH		"/addons/jk_botti/jk_botti_names.txt"

#define _Permanent_Offset		g_jk_botti_data[_Timed_Offset]
#define _Name_Offset_(%1)		g_jk_botti_data[%1]
#define _Read_Free_Names		None
#define _Read_Using_Names		Single
#define DEFAULT_PERCENT			50
#define IQ(%1)				g_Bot_Leave_Chance[%1]
#define SKILL_LEVELS			5
#define BOT_LEVEL			g_plugin_data[_Bot_Level]
#define CONNECT_CHANCE			g_Bot_Leave_Chance[0]

#define Array_Using_Names	g_array_data[Single]
#define Array_Free_Names	g_array_data[None]
#define Free_Names		(_Name > None)
#define _Name			g_plugin_data[_Max_Names]
#define Max_Bots_On_Server	g_plugin_data[_Max_Bots]
#define Flags			g_plugin_data[_Plugin_Flags]
#define Task_Connect		7843513947
#define Task_ai			8514290367
#define None			0
#define Single			1
#define Total_Clients		g_plugin_data[_Clients_Total]

#define FL_THIRDPARTYBOT 	(1 << 27) /* jk_botti sources - "bot.h" */
#define MaxPlayers 		g_plugin_data[_Max_Players]
#define Bots_On_Server 		g_plugin_data[_Total_jk_botti_Bots]

#define jk_botti_bot_add(%1)	g_plugin_data[_bit_jk_botti] |= 1 << (%1 - 1)
#define jk_botti_bot_sub(%1)	g_plugin_data[_bit_jk_botti] &= ~(1 << (%1 - 1))
#define jk_botti_bot(%1)	g_plugin_data[_bit_jk_botti] & 1 << (%1 - 1)

#define is_bot_add(%1)		g_plugin_data[_bit_bot]	|= 1 << (%1 - 1)
#define is_bot_sub(%1)		g_plugin_data[_bit_bot] &= ~(1 << (%1 - 1))
#define is_bot(%1)		g_plugin_data[_bit_bot] & 1 << (%1 - 1)

#define PLUGIN 	"jk_botti_ai_control"
#define VERSION "0.2c3"
#define AUTHOR 	"Turanga_Leela"

new
g_plugin_data[Plugin_Data],
Float:g_Bot_Leave_Chance[33],
Array:g_array_data[2],
g_jk_botti_data[Bot_Data] = {-1, ...}

#define _hard_		2.0
#define _advanced_ 	2.5
#define _normal_	3.0
#define _average_	3.5
#define _easy_		4.0

public all_in_1(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)

		return PLUGIN_HANDLED
	}

	new

	s_Data[6],
	s_Name[16],
	i_Access,
	i_Callback,
	Menu_id = None

	menu_item_getinfo(menu, item, i_Access, s_Data, charsmax(s_Data), s_Name, charsmax(s_Name), i_Callback)

	new i_Key = str_to_num(s_Data)

	switch(g_plugin_data[id])
	{
		case 1:
		{
                        new const __Choose[] =
                        {
                                0x2,
                                0x3,
                                0x4
                        }

                        Menu_id = __Choose[i_Key - 0x1]
		}

		case 2:
		{
			if(i_Key ^ 0x7)
                        {
                                new const i__Difficulty[] =
                                {
                                        0x0,
                                        0x5,
                                        0x4,
                                        0x3,
                                        0x2,
                                        0x1
                                }

                                Flags &= ~flag_Block

                                new

                                string[64],
                                difficulty = (PRIORITY_DIFFICULTY = i__Difficulty[i_Key - 0x1])

                                switch(add_random_bot())
                                {
                                        case add_No_Nickname:
                                        {
                                                string = "Failed! Can't create bot! #Reason: <'No Free NickName'>"
                                        }

                                        case add_False:
                                        {
                                                //new bug_test = 0;
						  
                                                if(1 << Total_Clients & (1 << Max_Bots_On_Server | 1 << (Max_Bots_On_Server - 1)))
                                                {
                                                        string = "Failed! Can't create bot! #Reason: <'No Slots'>"
                                                        //bug_test = 1;
                                                }

                                                else
                                                {
                                                        string = "Failed! Can't create bot! #Reason: <Blocked by - 'ai'>"
                                                        //bug_test = 2;
                                                }
                                                
                                                server_print("^n^nClients on server = %d^nMax bots on server = %d^nBots on server = %d^n^n", Total_Clients, Max_Bots_On_Server, Bots_On_Server);
                                        }

                                        case add_True:
                                        {
                                                new const skills[][] =
                                                {
                                                        "<Random>",
                                                        "<Nightmare!>",
                                                        "<Hardcore>",
                                                        "<Hurt Me Plenty>",
                                                        "<Bring It On>",
                                                        "<I Can Win>"
                                                }

                                                formatex(string, charsmax(string), "%s %s", "Done! Created successfully!", skills[difficulty])
                                        }

                                        default:
                                        {
                                                return PLUGIN_HANDLED
                                        }
                                }

                                client_print(id, print_chat, "%s %s", "[jk_botti]:", string)

                                Menu_id = 2
                        }

                        else
                        {
                                Menu_id = 1
                        }
		}

		case 3:
		{
			switch(i_Key)
			{
				case 1:
                                {
                                        for(new i = 1; i <= MaxPlayers; i++)
                                        {
                                                if(jk_botti_bot(i)) // is_bot(i)
                                                {
                                                        user_kill(i, Single)
                                                }
                                        }

                                        client_print(id, print_chat, "%s %s", "[jk_botti]:", Bots_On_Server ? "Done! All Killed!" : "Failed! #Found - '0'")
                                        Menu_id = 3
                                }

                                case 2:
				{
					server_cmd("jk_botti kickall")
					client_print(id, print_chat, "%s %s", "[jk_botti]:", Bots_On_Server ? "Done! All Removed!" : "Failed! #Found - '0'")

					Menu_id = 3
				}

				case 3:
				{
					new ignore = None

					if((ignore = (flag_Observer & ~Flags)))
					{
						Flags |= flag_Observer
						ignore = 1
					}

					else
					{
						Flags &= ~flag_Observer
					}

					server_cmd("%s %d", "jk_botti observer", ignore)

					Menu_id = 3
				}

				case 4:
				{
					new freeze = None

					if((freeze = (Flags & flag_Freeze)))
					{
						Flags &= ~flag_Freeze
						freeze = Bot_UN_Freeze
					}

					else
					{
						Flags |= flag_Freeze
						freeze = Bot_Freeze
					}

					for(new index = 1; index <= MaxPlayers; index++)
					{
						if(is_bot(index))
						{
							jk_botti_bot_pause(index, freeze)
						}
					}

					Menu_id = 3
				}

				case 5:
				{
					jk_botti_change_ai()
					Menu_id = 3
				}

				case 6:
				{
					Menu_id = 1
				}
			}
		}

		case 4:
		{
			switch(i_Key)
			{
				case 1:	Menu_id = 5
				case 2:	client_cmd(id, "messagemode #set_value")
				case 3:	Menu_id = 1
			}
		}

		case 5:
		{
			if(i_Key ^ 0x7)
                        {
                                new const i_Difficulty[] =
                                {
                                        0x0,
                                        0x5,
                                        0x4,
                                        0x3,
                                        0x2,
                                        0x1
                                }

                                CHANGE_DIFFICULTY((VALUE_DIFFICULTY = i_Difficulty[i_Key - 0x1]))
                        }

			Menu_id = 4
		}
	}

        main_menu(id, Menu_id)

	return PLUGIN_HANDLED
}

main_menu(id, mode)
{
	#define Menu(%1) Menu_Contents[%1 - 1]

	new const Menu_Contents[][] =
	{
		"\r[jk_botti]: Main Menu",
		"\r[jk_botti]: Select 'ai' Level",
		"\r[jk_botti]: 'ai' Control Panel",
		"\r[jk_botti]: Settings Panel",
		"\r[jk_botti]: Choose Default Difficulty"
	}

	new menu = menu_create(Menu(mode), "all_in_1")
	g_plugin_data[id] = mode

	switch(mode)
	{
		case 1:
		{
			menu_additem(menu, "\w<jk_botti>++", 	"1")
			menu_additem(menu, "\w'ai' Control", 	"2")
			menu_additem(menu, "\wSettings", 	"3")
		}

		case 2, 5:
		{
			menu_additem(menu, "\wRandom", 		"1")
			menu_addblank(menu, None)
			menu_additem(menu, "\wI Can Win", 	"2")
			menu_additem(menu, "\wBring It On", 	"3")
			menu_additem(menu, "\wHurt Me Plenty", 	"4")
			menu_additem(menu, "\wHardcore", 	"5")
			menu_additem(menu, "\wNightmare!", 	"6")
			menu_addblank(menu, None)
			menu_additem(menu, "\wPrevious Menu", 	"7")
		}

		case 3:
		{
			menu_additem(menu, "\wKill all bots", 	"1")
			menu_additem(menu, "\wRemove all bots",	"2")
			menu_addblank(menu, None)

			menu_additem(menu, (flag_Observer & Flags) ? "\wIgnore Humans [ON]" : "\wIgnore Humans [OFF]", "3")
			menu_additem(menu, (flag_Freeze & Flags) ? "\wFreeze [ON]" : "\wFreeze [OFF]", "4")
			menu_additem(menu, (flag_ai_Enable & Flags) ? "\w'ai' [ON]" : "\w'ai' [OFF]", "5")
			menu_addblank(menu, None)
			menu_additem(menu, "\wPrevious Menu", 	"6")
		}

		case 4:
		{
			new string[64]

			switch(VALUE_DIFFICULTY)
			{
				case 1:		string = "\wDefault difficulty [<Nightmare!>]"
				case 2:		string = "\wDefault difficulty [<Hardcore>]"
				case 3:		string = "\wDefault difficulty [<Hurt Me Plenty>]"
				case 4:		string = "\wDefault difficulty [<Bring It On>]"
				case 5:		string = "\wDefault difficulty [<I Can Win>]"

				default:	string = "\wDefault difficulty [<Random>]"
			}

			menu_additem(menu, string, "1")

			formatex(string, charsmax(string), "%s%d%s", "\wSlot Reservation [", VALUE_SLOTS, "%]")

			menu_additem(menu, string, "2")
			menu_addblank(menu, None)
			menu_additem(menu, "\wPrevious Menu", 	"3")
		}
	}

	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL)
	menu_display(id, menu, 0)

	return PLUGIN_CONTINUE
}

public check_valid_players()
{
	if(Flags & flag_ai_Enable && Free_Names && Total_Clients < Max_Bots_On_Server)
	{
		new

		index,
		Float:chance = 100.0 / CONNECT_CHANCE

		if(1 < (index = (Max_Bots_On_Server - Bots_On_Server)))
		{
			chance /= (index * random_float(1.1, 1.5))
		}

		if(random_float(0.0, chance) <= 1.0)
		{
			add_random_bot()
		}
	}
}

jk_botti_names(mode, id = None)
{
	new size = ArraySize(g_array_data[mode])

	if(!size)
	{
		return -1
	}

	new

	NameOffset,
	remove

	if(id)
	{
		NameOffset = _Name_Offset_(id)

		new

		line,
		except

		do
		{
			except = ArrayGetCell(g_array_data[_Read_Using_Names], line)
			line++
		}
		while(except != NameOffset)

		ArrayDeleteItem(g_array_data[_Read_Using_Names], line - 1)
		ArrayPushCell(g_array_data[_Read_Free_Names], NameOffset)

		return None
	}

	switch(size)
	{
		case 1:
		{
			NameOffset = ArrayGetCell(g_array_data[_Read_Free_Names], None)
			remove = None
		}

		default:
		{
			remove = random(size)
			NameOffset = ArrayGetCell(g_array_data[_Read_Free_Names], remove)
		}
	}

	ArrayDeleteItem(g_array_data[_Read_Free_Names], remove)
	ArrayPushCell(g_array_data[_Read_Using_Names], NameOffset)

	return NameOffset
}

public add_random_bot()
{
	if(Total_Clients < Max_Bots_On_Server)
	{
		if(Flags & flag_Block)
		{
			Flags ^= flag_Block

			return add_Reset
		}

		new NameOffset

		if((NameOffset = jk_botti_names(_Read_Free_Names)) == -1)
		{
			return add_No_Nickname
		}

		new

		line_len,
		jk_botti_name[32],
		difficulty = VALUE_DIFFICULTY

		_Permanent_Offset = NameOffset
		read_file(BOT_NAMES_CONFIG_PATH, NameOffset, jk_botti_name, charsmax(jk_botti_name), line_len)

		if(PRIORITY_DIFFICULTY)
		{
			difficulty = PRIORITY_DIFFICULTY
			PRIORITY_DIFFICULTY = None
		}

		if(!difficulty)
		{
			difficulty = random_num(1, 5)
		}

		BOT_LEVEL = difficulty - 1

                enum {_Models = 0xA}

		new const jk_botti_models[_Models][] =
		{
			"barney",
			"gina",
			"gman",
			"gordon",
			"helmet",
			"hgrunt",
			"recon",
			"robo",
			"scientist",
			"zombie"
		}

		server_cmd("jk_botti botskill %d", difficulty)
		server_cmd("jk_botti addbot %s %s %d", jk_botti_models[random(_Models)], jk_botti_name, difficulty)

		return add_True
	}

	return add_False
}

public jk_botti_bot_think()
{
	if(Flags & flag_ai_Enable)
	{
		new id = read_data(2)

		switch(jk_botti_bot(id))
		{
			case None:
			{
				if(Free_Names && Total_Clients < Max_Bots_On_Server && random_float(0.0, (100.0 / CONNECT_CHANCE)) <= 1.0 && !task_exists(Task_Connect))
				{
					set_task(float(random_num(5, 15)), "add_random_bot", Task_Connect)
				}
			}

			default:
			{
				if(random_float(0.0, (100.0 / IQ(id))) <= 1.0 && !task_exists(id))
				{
					set_task(float(random_num(1, 5)), "jk_botti_bot_kick", id)
				}
			}
		}
	}
}

public jk_botti_bot_kick(id)
{
	if(is_bot(id))
        {
		new BotName[32]

		get_user_name(id, BotName, charsmax(BotName))
		server_cmd("%s %s", "kick", BotName)
	}
}

public client_disconnect(id)
{
	Total_Clients--

	if(is_bot(id))
	{
		Flags |= flag_Block | flag_Skip

		jk_botti_bot_pause(id, Bot_UN_Freeze)
		jk_botti_names(_Read_Using_Names, id)

		if(task_exists(id))
		{
			remove_task(id)
		}

		is_bot_sub(id)
		_Name_Offset_(id) = -1
		_Name++

		if(jk_botti_bot(id))
		{
			IQ(id) = 0.0
			jk_botti_bot_sub(id)
			Bots_On_Server--
		}
	}
}

public client_putinserver(id)
{
	if(is_bot(id))
	{
		if(!task_exists(id + 32))
		{
			set_task(0.5, "jk_botti_addbot", id + 32)

			return
		}

		jk_botti_bot_kick(id)
	}
}

public jk_botti_addbot(index)
{
	new id = index - 32

	if(is_bot(id) && pev(id, pev_flags) & FL_THIRDPARTYBOT)
	{
		new const Float:Bot_Leave_Chance[SKILL_LEVELS] =
		{
			_hard_,
			_advanced_,
			_normal_,
			_average_,
			_easy_
		}

		IQ(id) = Bot_Leave_Chance[BOT_LEVEL]
		jk_botti_bot_add(id)
		Bots_On_Server++

		set_user_frags(id, None)
		hl_set_user_deaths(id, None)
	}
}

jk_botti_change_ai()
{
	if(task_exists(Task_ai))
	{
		Flags &= ~flag_ai_Enable

		remove_task(Task_ai)
	}

	else
	{
		Flags |= flag_ai_Enable

		set_task(Float:Check_Time, "check_valid_players", Task_ai, _, _, "b")
	}
}

public jk_botti_bot_spawn_post(id)
{
	if(flag_Freeze & Flags)
	{
		jk_botti_bot_pause(id, Bot_Freeze)
	}
}

jk_botti_bot_pause(id, mode)
{
	if(is_bot(id))
	{
		new Float:speed

		switch(mode)
		{
			case Bot_Freeze:
			{
				strip_user_weapons(id)
				speed = -1.0
			}

			case Bot_UN_Freeze:
			{
				switch(flag_Skip & Flags)
				{
					case None:
					{
						give_item(id, "weapon_crowbar")
						give_item(id, "weapon_glock")
						give_item(id, "ammo_9mmclip")
					}

					default:
					{
						Flags &= ~flag_Skip
					}
				}

				speed = float(get_cvar_num("sv_maxspeed"))
			}
		}

		set_user_maxspeed(id, speed)
	}
}

public client_connect(id)
{
	Total_Clients++

	if(task_exists(Task_Connect))
	{
		remove_task(Task_Connect)
	}

	if(is_user_bot(id))
	{
		is_bot_add(id)
		_Name_Offset_(id) = _Permanent_Offset
		_Name--
	}

	if(Flags & flag_ai_Enable && Bots_On_Server && Total_Clients >= Max_Bots_On_Server)
	{
		new

		jk_botti[32],
		bot = None

		for(new index = 1; index <= MaxPlayers; index++)
		{
			if(jk_botti_bot(index))
			{
				jk_botti[bot++] = index
			}
		}

		if(bot)
		{
			new task_id = jk_botti[random(bot)]

			if(!task_exists(task_id))
			{
				set_task(float(random_num(1, 5)), "jk_botti_bot_kick", task_id)
			}
		}
	}
}

change_value(mode, value)
{
	new

	string[32],
	offset

	switch(mode)
	{
		case None:
		{
			string = "default_difficulty = "
			offset = OFFSET_DIFFICULTY
		}

		default:
		{
			string = "available_slots(in '%') = "
			offset = OFFSET_SLOTS
		}
	}

	formatex(string ,charsmax(string), "%s%d", string, value)
	write_file(CONFIG_PATH, string, offset)
}

get_value(const string[])
{
	new

	left[32],
	right[32]

	strtok(string, left, charsmax(left), right, charsmax(right), '=')

	return str_to_num(right)
}

bool:read_config()
{
	#define Read_Bot_Config None
	#define Read_Plugin_Config Single
	#define Read_Names_Config 2
	#define Current_Config i

        enum {_Dir_Count = 0x3}

	new const configs_dir[_Dir_Count][] =
	{
		BOT_CONFIG_PATH,
		CONFIG_PATH,
		BOT_NAMES_CONFIG_PATH
	}

	new

	line,
	line_len,
	string[32],
	_text[32],
	success,
	i,
	Trie:_Trie_Handle = TrieCreate()

        enum {_Blocked = 0x5}

	new const blocked_lines[_Blocked][] =
	{
		"addbot",
		"max_bots",
		"min_bots",
		"bot_conntimes",
		"observer"
	}

	for(new j; j < _Blocked; j++)
	{
		TrieSetString(_Trie_Handle, blocked_lines[j], "")
	}

	for(i = None; i < _Dir_Count; i++)
	{
		while(read_file(configs_dir[Current_Config], line++, string, charsmax(string), line_len))
		{
			if(line_len && string[None] != '#')
			{
				switch(Current_Config)
				{
					case Read_Bot_Config:
					{
						copyc(_text, charsmax(_text), string, ' ')

						if(TrieKeyExists(_Trie_Handle, _text))
						{
							write_file(BOT_CONFIG_PATH, "", line - 1)
						}
					}

					case Read_Plugin_Config:
					{
						if(equali(string, "default_difficulty", 18))
						{
							OFFSET_DIFFICULTY = line - 1
							VALUE_DIFFICULTY = get_value(string)

							if(!(None <= VALUE_DIFFICULTY <= 5))
							{
								VALUE_DIFFICULTY = None
								CHANGE_DIFFICULTY(VALUE_DIFFICULTY)
							}

							success++
						}

						else if(equali(string, "available_slots(in '%')", 23))
						{
							OFFSET_SLOTS = line - 1
							VALUE_SLOTS = get_value(string)

							if(!(10 <= VALUE_SLOTS <= 90))
							{
								VALUE_SLOTS = DEFAULT_PERCENT
								CHANGE_SLOTS(VALUE_SLOTS)
							}

							success++
						}
					}

					case Read_Names_Config:
					{
						if(string[None] == ' ')
						{
							continue
						}

						ArrayPushCell(Array_Free_Names, _Name)
						_Name++
					}
				}
			}
		}

		line = None
	}

	TrieDestroy(_Trie_Handle)

	if(success ^ 0x2 || !_Name)
	{
		return false
	}

	return true
}

bool:check_config()
{
	if(!file_exists(CONFIG_PATH))
	{
		OFFSET_SLOTS = 0x5
		OFFSET_DIFFICULTY = 0x4

		VALUE_DIFFICULTY = None
		VALUE_SLOTS = DEFAULT_PERCENT

		return bool:(write_file(CONFIG_PATH, "# [jk_botti] - Config^n#^n# Line starts with - '#' is a comment^n^ndefault_difficulty = 0^navailable_slots(in '%') = 50^n", -1))
	}

	return read_config()
}

public plugin_precache()
{
	Array_Using_Names = ArrayCreate(1,1)
	Array_Free_Names = ArrayCreate(1,1)
}

public plugin_cfg()
{
	if(check_config())
	{
		MaxPlayers = get_maxplayers()
		Max_Bots_On_Server = floatround(MaxPlayers * VALUE_SLOTS * 0.01)
		CONNECT_CHANCE = ((_easy_ + _average_ + _normal_ + _advanced_ + _hard_) / SKILL_LEVELS.0)

		register_event("DeathMsg", "jk_botti_bot_think", "a")
		RegisterHam(Ham_Spawn, "player", "jk_botti_bot_spawn_post", 1)
		register_plugin(PLUGIN, VERSION, AUTHOR)

		register_clcmd("jk_botti_control", "jk_botti_menu")
		register_clcmd("#set_value", "set_available_slots")

		server_cmd("jk_botti min_bots %d", -Single)
		server_cmd("jk_botti max_bots %d", -Single)
		server_cmd("jk_botti bot_conntimes %d", Single)
		server_cmd("jk_botti observer %d", None)

		jk_botti_change_ai()

#if defined DEBUG_ON
		register_concmd("names", "check_names")
#endif
		return PLUGIN_CONTINUE
	}

	server_print("***********^n[jk_botti]: 'ai' - Disabled! (Config problem) ^nAlso check: [<jk_botti_names.txt>] - Empty!^n***********")

	return PLUGIN_CONTINUE
}

#if defined DEBUG_ON
public check_names(id)
{
	new i = ArraySize(g_array_data[_Read_Free_Names])

	if(i)
	{
		server_print("Name value: %d", _Name)

		while(i)
		{
			new h = ArrayGetCell(g_array_data[_Read_Free_Names], i - 1)
			server_print("Name Offset: %d", h)
			i--
		}
	}
}
#endif

public set_available_slots(id)
{
	if(get_user_flags(id) & (ADMIN_FLAGS))
	{
		new

		string[4],
		value

		read_argv(1, string, charsmax(string))

		if(!(10 <= (value = str_to_num(string)) <= 90))
		{
			value = DEFAULT_PERCENT
			client_print(id, print_chat, "[jk_botti]: Failed! Available values: <[10 - 90]>")
		}

		VALUE_SLOTS = value
		Max_Bots_On_Server = floatround(MaxPlayers * VALUE_SLOTS * 0.01)
		CHANGE_SLOTS(VALUE_SLOTS)

		main_menu(id, 4)
	}
}

public jk_botti_menu(id)
{
	if(get_user_flags(id) & (ADMIN_FLAGS))
	{
		main_menu(id, Single)
	}
}
